import javax.realtime.*;

public class FaultEvt extends RealtimeThread{

  static int maxPriority;

  public FaultEvt(SchedulingParameters sched){
    super(sched);
  }

  public void run() {
    //  Create this method's fault notification
    AsyncEventHandler handler = new AsyncEventHandler() {
      public void handleAsyncEvent(){
        System.err.println("Run method: notified");
      }
    };
    AsyncEvent notify = new AsyncEvent();
    RealtimeThread thisThread = 
      RealtimeThread.currentRealtimeThread();

    handler.setSchedulingParameters((SchedulingParameters)
        (new PriorityParameters(maxPriority-3)));

    //  Make sure we hear about trouble 
    notify.addHandler(handler);
    process1(notify);
    notify.removeHandler(handler);
  }

  private void process1(AsyncEvent notify){
    //  Create this method's fault notification
    AsyncEventHandler p2Handler = new AsyncEventHandler() {
      public void handleAsyncEvent(){
        System.err.println("process1 method: notified");
      }
    };
    p2Handler.setSchedulingParameters((SchedulingParameters)
        (new PriorityParameters(maxPriority-4)));
    //  Make sure we hear about trouble 
    notify.addHandler(p2Handler);
    process2(notify);
    notify.removeHandler(p2Handler);
  }

  private void process2(AsyncEvent notify){
    //... something bad happened
    //  fire the notification asyncevent.
    {
      notify.fire();
      return;
    }
  }


  public static void main(String [] args){
    maxPriority = PriorityScheduler.getMaxPriority(null);
    SchedulingParameters sched = 
      (SchedulingParameters)(new PriorityParameters(maxPriority-5));
    FaultEvt me = new FaultEvt(sched);
    me.start();
    try{
      me.join();
    } catch (Exception e){};
    System.exit(0);
  }
}
